// Project: brick 2019-11-22
SetErrorMode(2)
SetWindowTitle( "Brick" )
SetWindowSize( GetMaxDeviceWidth(), GetMaxDeviceHeight(),1)
SetWindowAllowResize( 1 ) 
SetViewZoomMode( 1 )
SetVirtualResolution( GetMaxDeviceWidth(), GetMaxDeviceHeight() )
UseNewDefaultFonts( 1 )
SetPrintSize(30)
SetPrintColor(255,0,0)
SetVSync(1)
SetRawMouseVisible( 0)
CreateText(1,"F7 Full Screen - F8 Fenetre Echap Quit")
SetTextSize(1,30)
SetTextPosition(1,100,500)
SetTextColor(1,0,180,0,125)
Global lastTimeMS AS float
lastTimeMS = timer() 
Global newTimeMS# AS float
Global dt# AS float
global hauteur_ecran As integer
hauteur_ecran = GetMaxDeviceHeight()
global largeur_ecran As integer
largeur_ecran = GetMaxDeviceWidth()
Global n_ligne As integer
n_ligne = 40 
Global n_collone As integer
n_collone = 15
Type raquette
x As Float
y As Float
largeur As integer
hauteur As integer
Endtype
Global pad As raquette
pad.x = 1
pad.y = 1
pad.largeur = 80
pad.hauteur = 15
Type ball
x As Float
y As Float
rayon As integer
colle As integer
vx As Float
vy As Float
Endtype
Global balle As ball
balle.x = 1
balle.y = 1
balle.rayon = 10
balle.colle = 1
balle.vx = 0
balle.vy = 0
Type brique
largeur As integer
hauteur As integer
Endtype	
Global brick As brique
brick.hauteur = 15
brick.largeur = largeur_ecran / n_ligne
Dim niveau[n_collone,n_ligne] As Integer	
function Demarre()
	balle.colle = 1	
	for l = 1 to n_collone
		for c = 1 to n_ligne
			niveau[l,c] =1
		next			
	next	
endfunction
Demarre()
repeat  
    newTimeMS# = timer()
    dt# = (newTimeMS# - lastTimeMS#)
    lastTimeMS# = newTimeMS#          
    If GetRawKeyPressed(118)
		SetWindowSize(GetMaxDeviceWidth(),GetMaxDeviceHeight(),1)
	Endif
    If GetRawKeyPressed(119)
		SetWindowSize(GetMaxDeviceWidth(),GetMaxDeviceHeight(),0)  
    Endif
	pad.x = GetRawMouseX()
	pad.y = GetMaxDeviceHeight()- (pad.hauteur / 2)
	if balle.colle = 1
		balle.x = pad.x
		balle.y = pad.y - pad.hauteur/2 - balle.rayon
	else
		balle.x = balle.x + (balle.vx*dt#)
		balle.y = balle.y + (balle.vy*dt#)	
	endif
	c = Floor(balle.x / brick.largeur) + 1
	l = Floor(balle.y / brick.hauteur) + 1
	if l >= 1 and l <= n_collone and c >= 1 and c <= n_ligne
		if niveau[l,c] = 1
			balle.vy = 0 - balle.vy
			niveau[l,c] = 0
		endif
	endif	
	if GetRawMouseLeftPressed()
		if balle.colle = 1 
			balle.colle = 0
			balle.vx = 500
			balle.vy = -500
		endif	
	endif
	if balle.x > largeur_ecran
		balle.vx = 0 - balle.vx	
		balle.x = largeur_ecran
	endif
	if balle.x < 0
		balle.vx = 0 - balle.vx	
		balle.x = 0
	endif	
	if balle.y < 0
		balle.vy = 0 - balle.vy
		balle.y = 0
	endif
	if balle.y > hauteur_ecran
		balle.colle = 1
	endif
	posCollisionPad = pad.y - (pad.hauteur/2) - balle.rayon
	if balle.y > posCollisionPad
		dist = Abs(pad.x - balle.x)
		if dist < pad.largeur / 2
			balle.vy = 0 - balle.vy	
			balle.y = posCollisionPad
		endif
	endif 
	coul1 = Random(0,255)
	coul2 = Random(0,255)
	coul3 = Random(0,255)
	DrawBox( pad.x - (pad.largeur / 2), pad.y - (pad.hauteur / 2), pad.x + (pad.largeur / 2), pad.y + (pad.hauteur / 2), MakeColor(255,0,0),MakeColor(255,0,0), MakeColor(255,0,0), MakeColor(255,0,0), 1 )
	DrawEllipse( balle.x, balle.y, balle.rayon, balle.rayon, MakeColor(255,255,0), MakeColor(255,255,0), 1)
	bx = 0
	by = 0		
	for l = 1 to n_collone	
		bx = 0		
		for c = 1 to n_ligne
			if niveau[l,c] = 1
			DrawBox( bx+1, by+1, bx+(brick.largeur-2), by+(brick.hauteur-2), MakeColor(0,0,255),MakeColor(255,255,255), MakeColor(255,255,255), MakeColor(255,255,255), 1 )
			endif 		
			bx = bx + brick.largeur
		next
		by = by + brick.hauteur
    next
    Sync()
until GetRawKeyPressed(27) = 1  
